
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>

// le type cellule d'une liste chainee
struct cellule_t {
    int val;
    struct cellule_t *suiv;
};

// cree une liste chainee a partir d'un tableau d'entiers termine par -1
// les elements sont inseres dans le meme ordre que dans le tableau initial
struct cellule_t *cree_liste(int tab[])
{
    struct cellule_t sent;
    struct cellule_t *queue;
    for (queue = &sent; *tab != -1; tab++) {
        queue->suiv = malloc(sizeof(struct cellule_t));
        assert(queue->suiv != NULL);
        queue = queue->suiv;
        queue->val = *tab;
    } 
    queue->suiv = NULL;
    return sent.suiv;
}

// affiche une liste chainee d'entiers
void affiche_liste(struct cellule_t *liste)
{
    for (; liste != NULL; liste = liste->suiv) {
        printf("%d -> ", liste->val);
    }
    printf("FIN\n");
}

// prototype de la fonction externe de decoupage, implantee en assembleur
struct cellule_t *decoupe(struct cellule_t *l, struct cellule_t **l1, struct cellule_t **l2);

// un tableau de test
int tableau[] = {4, 3, 1, 6, 5, 3, 2, 4, 7, 2, -1};

// le test donne pour l'exemple dans le programme principal n'est bien sur pas
//   suffisant, ajoutez-en d'autres !
int main(void)
{
    struct cellule_t *liste;
    liste = cree_liste(tableau);
    affiche_liste(liste);
    struct cellule_t *l1, *l2;
    liste = decoupe(liste, &l1, &l2);
    affiche_liste(liste);
    affiche_liste(l1);
    affiche_liste(l2);
    return 0;
}

